package FunctionLayer.StanfordParser;

import FunctionLayer.LevenshteinDistance;
import FunctionLayer.SimilarityMatrix;
import FunctionLayer.StopwordAnnotator;
import edu.mit.jmwe.data.IMWE;
import edu.mit.jmwe.data.IMWEDesc;
import edu.mit.jmwe.data.IToken;
import edu.stanford.nlp.ie.AbstractSequenceClassifier;
import edu.stanford.nlp.ling.CoreAnnotations;
import edu.stanford.nlp.ling.CoreLabel;
import edu.stanford.nlp.ling.HasWord;
import edu.stanford.nlp.ling.IndexedWord;
import edu.stanford.nlp.ling.JMWEAnnotation;
import edu.stanford.nlp.ling.TaggedWord;
import edu.stanford.nlp.neural.rnn.RNNCoreAnnotations;
import edu.stanford.nlp.pipeline.Annotation;
import edu.stanford.nlp.pipeline.CoreDocument;
import edu.stanford.nlp.pipeline.CoreEntityMention;
import edu.stanford.nlp.process.CoreLabelTokenFactory;
import edu.stanford.nlp.process.DocumentPreprocessor;
import edu.stanford.nlp.process.PTBTokenizer;
import edu.stanford.nlp.process.TokenizerFactory;
import edu.stanford.nlp.sentiment.SentimentCoreAnnotations;
import edu.stanford.nlp.sequences.DocumentReaderAndWriter;
import edu.stanford.nlp.tagger.maxent.MaxentTagger;
import edu.stanford.nlp.trees.Constituent;
import edu.stanford.nlp.trees.GrammaticalRelation;
import edu.stanford.nlp.trees.GrammaticalStructure;
import edu.stanford.nlp.trees.GrammaticalStructureFactory;
import edu.stanford.nlp.trees.Tree;
import edu.stanford.nlp.trees.TreeCoreAnnotations;
import edu.stanford.nlp.trees.TypedDependency;
import edu.stanford.nlp.trees.tregex.gui.Tdiff;
import edu.stanford.nlp.util.CoreMap;
import edu.stanford.nlp.util.Pair;

import java.io.StringReader;
import java.util.*;

import org.apache.lucene.analysis.core.StopAnalyzer;
import org.ejml.simple.SimpleMatrix;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * @author install1
 */
public class SentimentAnalyzerTest {

    private final SimilarityMatrix smxParam;
    private final String str;
    private final String str1;
    private final MaxentTagger tagger;
    private final GrammaticalStructureFactory gsf;
    private final AbstractSequenceClassifier classifier;
    private final List<CoreMap> coreMaps1;
    private final List<CoreMap> coreMaps2;
    private final Annotation pipelineAnnotation1;
    private final Annotation pipelineAnnotation2;
    private final Annotation pipelineAnnotation1Sentiment;
    private final Annotation pipelineAnnotation2Sentiment;
    private final CoreDocument pipelineCoreDcoument1;
    private final CoreDocument pipelineCoreDcoument2;

    public Integer getTokenizeCounting() {
        return tokenizeCounting;
    }

    public List<List<TaggedWord>> getTaggedWordListF() {
        return taggedWordListF;
    }

    public List<List<TaggedWord>> getTaggedWordList1() {
        return taggedWordList1;
    }

    public ArrayList<String> getRetrieveTGWList1() {
        return retrieveTGWList1;
    }

    public List<CoreMap> getSentencesF() {
        return sentencesF;
    }

    public Integer getTokenizeCountingF() {
        return tokenizeCountingF;
    }

    public ArrayList<String> getRetrieveTGWListF() {
        return retrieveTGWListF;
    }

    public List<CoreMap> getSentences1() {
        return sentences1;
    }

    public List<CoreMap> getSentencesSentimentF() {
        return sentencesSentimentF;
    }

    public List<CoreMap> getSentencesSentiment1() {
        return sentencesSentiment1;
    }

    public ArrayList<Tree> getTreesF() {
        return treesF;
    }

    public ArrayList<Tree> getTrees1() {
        return trees1;
    }

    //caches
    private Integer tokenizeCounting;
    private Integer tokenizeCountingF;
    private List<List<TaggedWord>> taggedWordListF;
    private List<List<TaggedWord>> taggedWordList1;
    private ArrayList<String> retrieveTGWList1;
    private ArrayList<String> retrieveTGWListF;
    private List<CoreMap> sentencesF;
    private List<CoreMap> sentences1;
    private List<CoreMap> sentencesSentimentF;
    private List<CoreMap> sentencesSentiment1;
    private ArrayList<Tree> treesF;
    private ArrayList<Tree> trees1;


    public SentimentAnalyzerTest(String str, String str1, SimilarityMatrix smxParam, List<CoreMap> coreMaps1, List<CoreMap> coreMaps2,
                                 Annotation strPipeline1, Annotation strPipeline2, Annotation strPipeSentiment1, Annotation strPipeSentiment2,
                                 CoreDocument pipelineCoreDcoument1, CoreDocument pipelineCoreDcoument2,
                                 MaxentTagger tagger, GrammaticalStructureFactory gsf,
                                 AbstractSequenceClassifier classifier, Integer tokenizeCounting,
                                 Integer tokenizeCountingF, List<List<TaggedWord>> taggedWordListF,
                                 List<List<TaggedWord>> taggedWordList1, ArrayList<String>
                                         retrieveTGWListF, ArrayList<String> retrieveTGWList1,
                                 List<CoreMap> sentencesF, List<CoreMap> sentences1,
                                 List<CoreMap> sentencesSentimentF, List<CoreMap> sentencesSentiment1,
                                 ArrayList<Tree> treesF, ArrayList<Tree> trees1) {
        this.str = str;
        this.str1 = str1;
        this.smxParam = smxParam;
        this.tagger = tagger;
        this.gsf = gsf;
        this.classifier = classifier;
        this.coreMaps1 = coreMaps1;
        this.coreMaps2 = coreMaps2;
        this.pipelineAnnotation1 = strPipeline1;
        this.pipelineAnnotation2 = strPipeline2;
        this.pipelineAnnotation1Sentiment = strPipeSentiment1;
        this.pipelineAnnotation2Sentiment = strPipeSentiment2;
        this.pipelineCoreDcoument1 = pipelineCoreDcoument1;
        this.pipelineCoreDcoument2 = pipelineCoreDcoument2;
        this.tokenizeCounting = tokenizeCounting;
        this.tokenizeCountingF = tokenizeCountingF;
        this.taggedWordListF = taggedWordListF;
        this.taggedWordList1 = taggedWordList1;
        this.retrieveTGWListF = retrieveTGWListF;
        this.retrieveTGWList1 = retrieveTGWList1;
        this.sentencesF = sentencesF;
        this.sentences1 = sentences1;
        this.sentencesSentimentF = sentencesSentimentF;
        this.sentencesSentiment1 = sentencesSentiment1;
        this.treesF = treesF;
        this.trees1 = trees1;
    }

    private List<List<TaggedWord>> getTaggedWordList(String message) {
        List<List<TaggedWord>> taggedwordlist = new ArrayList();
        DocumentPreprocessor tokenizer = new DocumentPreprocessor(new StringReader(message));
        TokenizerFactory<CoreLabel> ptbTokenizerFactory = PTBTokenizer.factory(new CoreLabelTokenFactory(), "untokenizable=noneDelete"); //noneDelete //firstDelete
        tokenizer.setTokenizerFactory(ptbTokenizerFactory);
        for (final List<HasWord> sentence : tokenizer) {
            taggedwordlist.add(tagger.tagSentence(sentence));
        }
        return taggedwordlist;
    }

    private int tokenizeCounting(List<List<TaggedWord>> taggedwordlist) {
        int counter = 0;
        for (List<TaggedWord> taggedList : taggedwordlist) {
            counter += taggedList.size();
        }
        return counter;
    }

    private ArrayList<String> retrieveTGWListIndex(List<List<TaggedWord>> taggedwordlist) {
        ArrayList<String> tgwlistIndex = new ArrayList<String>();
        for (List<TaggedWord> tGWList : taggedwordlist) {
            for (TaggedWord taggedWord : tGWList) {
                for (String str : tgwlistIndex) {
                    if (!taggedWord.tag().equals(str) && !taggedWord.tag().equals(":")) {
                        tgwlistIndex.add(taggedWord.tag());
                        tGWList.remove(taggedWord);
                    }
                }
            }
        }
        return tgwlistIndex;
    }

    private Double iterateTrees(ArrayList<Tree> sentenceConstituencyParseList2, ArrayList<Tree> sentenceConstituencyParseList1,
                                Double score) {
        double preConstituentsScore = score;
        ArrayList<Integer> constituentsMap = new ArrayList<Integer>();
        int constituencySize = sentenceConstituencyParseList1.size() + sentenceConstituencyParseList2.size();
        for (final Tree sentenceConstituencyParse2 : sentenceConstituencyParseList2) {
            int constiRelationsize = 0;
            for (final Tree sentenceConstituencyParse1 : sentenceConstituencyParseList1) {
                Set<Constituent> constinuent1 = Tdiff.markDiff(sentenceConstituencyParse1, sentenceConstituencyParse2);
                Set<Constituent> constinuent2 = Tdiff.markDiff(sentenceConstituencyParse2, sentenceConstituencyParse1);
                ArrayList<String> constiLabels = new ArrayList<String>();
                for (final Constituent consti : constinuent1) {
                    for (final Constituent consti1 : constinuent2) {
                        if (consti.value().equals(consti1.value()) && !constiLabels.contains(consti.value())) {
                            constiLabels.add(consti.value());
                            constiRelationsize++;
                        }
                    }
                }
                int constituents1 = constinuent1.size() - constiRelationsize;
                int constituents2 = constinuent2.size() - constiRelationsize;
                constituentsMap.add(constituents1);
                constituentsMap.add(constituents2);
                constituentsMap.add(constiRelationsize);
                if (constituentsMap.size() < 4) {
                    if ((constituents1 * 5 < constituents2 || constituents2 * 5 < constituents1) && constituents1 > 0 && constituents2 > 0) {
                        score -= (constituents1 + constituents2) * 200;
                    } else if ((constituents1 == 0 || constituents2 == 0) && (constituents1 >= constituents2 + 4 || constituents2 >= constituents1 + 4)) {
                        score -= constituents1 > constituents2 ? constituents1 * 500 : constituents2 * 500;
                    } else if (constiRelationsize >= constituents1 + constituents2 && (constituents1 > 2 && constituents2 > 2)) {
                        score += (constiRelationsize + constituents1 + constituents2) * 350;
                    } else if (constituents1 >= 2 && constituents2 >= 2 && constituents1 * 1.5 > constituents2 && constituents2 * 1.5 > constituents1) {
                        if (constituents1 == constituents2 && constiRelationsize - constituents1 == 1) {
                            score += (constiRelationsize + constituents1 + constituents2) * 1550;
                        } else if (constiRelationsize >= constituents1 && constituents1 == constituents2) {
                            score -= (constiRelationsize + constituents1 + constituents2) * 550;
                        } else if (constiRelationsize < constituents1 && constiRelationsize < constituents2) {
                            score += 800;
                        } else if ((constiRelationsize == constituents1 || constiRelationsize == constituents2) && constituents1 * 1.5 > constituents2
                                && constituents2 * 1.5 > constituents1) {
                            score += (constiRelationsize + constituents1 + constituents2) * 350;
                        }
                    } else if (constiRelationsize > constituents1 + constituents2) {
                        score += 2500;
                    } else if (constiRelationsize * 5 < constituents1 || constiRelationsize * 5 < constituents2) {
                        score -= (constituents1 + constituents2) * 400;
                    }
                } else {
                    score = preConstituentsScore;
                    int n1 = constituentsMap.get(0);
                    int n2 = constituentsMap.get(1);
                    int n3 = constituentsMap.get(2);
                    int cap = 0;
                    if (n1 > n2 && n1 > n3) {
                        cap = n1;
                    } else if (n2 > n3 && n2 > n1) {
                        cap = n2;
                    } else {
                        cap = n3;
                    }
                    int overheat = 0;
                    for (int iterator = 3; iterator < constituentsMap.size(); iterator++) {
                        Integer getConstituent = constituentsMap.get(iterator);
                        if (getConstituent > cap) {
                            overheat++;
                        }
                    }
                    if (overheat > 1) {
                        score -= overheat * 800;
                    } else {
                        score += 1300;
                    }
                }
            }
        }
        if (constituencySize > 10) {
            score -= constituencySize * 400;
        }
        return score;
    }

    private Double typeDependenciesGrammaticalRelation(Collection<TypedDependency> allTypedDependencies1, Collection<TypedDependency> allTypedDependencies2,
                                                       Double score, ArrayList<GrammaticalStructure> grammaticalMap1, ArrayList<GrammaticalStructure> grammaticalMap2,
                                                       ArrayList<Tree> sentenceConstituencyParseList1, ArrayList<Tree> sentenceConstituencyParseList2) {
        ArrayList<Integer> alltypeDepsSize1 = new ArrayList<Integer>();
        ArrayList<Integer> summationList = new ArrayList<Integer>();
        int relationApplicable1 = 0;
        int relationApplicable2 = 0;
        int grammaticalRelation1 = 0;
        int grammaticalRelation2 = 0;
        List<Tree> treeCollectionGramatical = new ArrayList();
        List<Tree> treeCollectionReln = new ArrayList();
        for (TypedDependency TDY1 : allTypedDependencies1) {
            IndexedWord dep = TDY1.dep();
            IndexedWord gov = TDY1.gov();
            for (GrammaticalStructure gs : grammaticalMap1) {
                GrammaticalRelation grammaticalRelation = gs.getGrammaticalRelation(gov, dep);
                for (Tree sentenceConstituencyParse2 : sentenceConstituencyParseList2) {
                    if (grammaticalRelation.isApplicable(sentenceConstituencyParse2) && !treeCollectionGramatical.contains(sentenceConstituencyParse2)) {
                        score += 700;
                        grammaticalRelation1++;
                        treeCollectionGramatical.add(sentenceConstituencyParse2);
                    }
                    GrammaticalRelation reln = TDY1.reln();
                    if (reln.isApplicable(sentenceConstituencyParse2) && !treeCollectionReln.contains(sentenceConstituencyParse2)) {
                        score += 525;
                        relationApplicable1++;
                        treeCollectionReln.add(sentenceConstituencyParse2);
                    }
                }
            }
        }
        treeCollectionGramatical = new ArrayList();
        treeCollectionReln = new ArrayList();
        for (TypedDependency TDY : allTypedDependencies2) {
            IndexedWord dep = TDY.dep();
            IndexedWord gov = TDY.gov();
            for (GrammaticalStructure gs : grammaticalMap2) {
                GrammaticalRelation grammaticalRelation = gs.getGrammaticalRelation(gov, dep);
                for (Tree sentenceConstituencyParse1 : sentenceConstituencyParseList1) {
                    if (grammaticalRelation.isApplicable(sentenceConstituencyParse1) && !treeCollectionGramatical.contains(sentenceConstituencyParse1)) {
                        score += 700;
                        grammaticalRelation2++;
                        treeCollectionGramatical.add(sentenceConstituencyParse1);
                    }
                    GrammaticalRelation reln = TDY.reln();
                    //sentenceConstituencyParse1
                    if (reln.isApplicable(sentenceConstituencyParse1) && !treeCollectionReln.contains(sentenceConstituencyParse1)) {
                        score += 525;
                        relationApplicable2++;
                        treeCollectionReln.add(sentenceConstituencyParse1);
                    }
                }
            }
        }
        if ((grammaticalRelation1 == 0 && grammaticalRelation2 > 4) || (grammaticalRelation2 == 0 && grammaticalRelation1 > 4)) {
            score -= 3450;
        }
        if (!allTypedDependencies1.isEmpty() || !allTypedDependencies2.isEmpty()) {
            int allTypeDep1 = allTypedDependencies1.size();
            int allTypeDep2 = allTypedDependencies2.size();
            if (allTypeDep1 <= allTypeDep2 * 5 && allTypeDep2 <= allTypeDep1 * 5) {
                if (allTypeDep1 > 0 && allTypeDep2 > 0 && (allTypeDep1 >= 5 || allTypeDep2 >= 5)) {
                    if ((allTypeDep1 + 1 == allTypeDep2 || allTypeDep2 + 1 == allTypeDep1)) {
                        score += allTypeDep1 > allTypeDep2 ? (allTypeDep1 - allTypeDep2) * 160 : (allTypeDep2 - allTypeDep1) * 160;
                    } else if (allTypeDep1 * 2.5 >= allTypeDep2 && allTypeDep2 * 2.5 >= allTypeDep1) {
                        score += allTypeDep1 > allTypeDep2 ? (allTypeDep1 - allTypeDep2) * 260 : (allTypeDep2 - allTypeDep1) * 260;
                    } else if (allTypeDep1 >= 5 && allTypeDep1 <= 10 && allTypeDep2 >= 5 && allTypeDep2 <= 10) {
                        score += allTypeDep1 > allTypeDep2 ? (allTypeDep1 - allTypeDep2) * 260 : (allTypeDep2 - allTypeDep1) * 260;
                    } else {
                        score -= allTypeDep1 > allTypeDep2 ? (allTypeDep1 - allTypeDep2) * 600 : (allTypeDep2 - allTypeDep1) * 600;
                    }
                    alltypeDepsSize1.add(allTypeDep1);
                    alltypeDepsSize1.add(allTypeDep2);
                }
            }
            if (allTypeDep1 >= 5 && allTypeDep2 >= 5) {
                int largerTypeDep = allTypeDep1 > allTypeDep2 ? allTypeDep1 : allTypeDep2;
                int smallerTypeDep = allTypeDep1 < allTypeDep2 ? allTypeDep1 : allTypeDep2;
                int summation = (largerTypeDep * largerTypeDep) - (smallerTypeDep * smallerTypeDep);
                if (summation / largerTypeDep < 15.0 && summation / largerTypeDep > 10.0 && smallerTypeDep * 2 > largerTypeDep
                        && !summationList.contains(summation)) {
                    score += summation * 80;
                    summationList.add(summation);
                } else if (largerTypeDep == smallerTypeDep) {
                    score += 2500;
                }
            }
            if (relationApplicable1 > 0 && relationApplicable2 > 0 && relationApplicable1 != relationApplicable2) {
                score += 600;
            } else if (allTypeDep1 * 5 < allTypeDep2 || allTypeDep2 * 5 < allTypeDep1) {
                score -= allTypeDep1 > allTypeDep2 ? (allTypeDep1 - allTypeDep2) * (allTypeDep2 * 450)
                        : (allTypeDep2 - allTypeDep1) * (allTypeDep1 * 450);
            }
            if (relationApplicable1 > 1 && relationApplicable2 > 1 && relationApplicable1 * 3 > relationApplicable2
                    && relationApplicable2 * 3 > relationApplicable1) {
                score += relationApplicable1 > relationApplicable2 ? (relationApplicable1 - relationApplicable2) * 1500
                        : (relationApplicable2 - relationApplicable1) * 1500;
            } else if (relationApplicable1 * 5 < relationApplicable2 || relationApplicable2 * 5 < relationApplicable1) {
                score -= relationApplicable1 > relationApplicable2 ? (relationApplicable1 - relationApplicable2) * 500
                        : (relationApplicable2 - relationApplicable1) * 500;
            }
            if (grammaticalRelation1 > 0 && grammaticalRelation2 > 0 && grammaticalRelation1 * 3 > grammaticalRelation2
                    && grammaticalRelation2 * 3 > grammaticalRelation1) {
                score += grammaticalRelation1 > grammaticalRelation2 ? (grammaticalRelation1 - grammaticalRelation2) * 1500
                        : (grammaticalRelation2 - grammaticalRelation1) * 1500;
            } else if (grammaticalRelation1 * 5 < grammaticalRelation2 || grammaticalRelation2 * 5 < grammaticalRelation1) {
                score -= grammaticalRelation1 > grammaticalRelation2 ? (grammaticalRelation1 - grammaticalRelation2) * 500
                        : (grammaticalRelation2 - grammaticalRelation1) * 500;
            }
        }
        ArrayList<String> filerTreeContent = new ArrayList<String>();
        int runCount1 = 0;
        for (Tree sentenceConstituencyParse1 : sentenceConstituencyParseList1) {
            for (Tree sentenceConstituencyParse2 : sentenceConstituencyParseList2) {
                for (CoreLabel LBW : sentenceConstituencyParse1.taggedLabeledYield()) {
                    for (CoreLabel LBW1 : sentenceConstituencyParse2.taggedLabeledYield()) {
                        if (LBW.lemma().equals(LBW1.lemma())) {
                            boolean found = false;
                            for (String str : filerTreeContent) {
                                if (str.equals(LBW.lemma())) {
                                    found = true;
                                    break;
                                }
                            }
                            if (!found) {
                                filerTreeContent.add(LBW.lemma());
                                runCount1++;
                            }
                        }
                    }
                }
            }
        }
        score += runCount1 * 250;
        int typeSizeSmallest = 100;
        int typeSizeLargest = 0;
        for (Integer i : alltypeDepsSize1) {
            if (i > typeSizeLargest) {
                typeSizeLargest = i;
            }
            if (i < typeSizeSmallest) {
                typeSizeSmallest = i;
            }
        }
        if (typeSizeLargest >= typeSizeSmallest * 3) {
            score -= typeSizeLargest * 160;
        }
        typeSizeLargest = 0;
        typeSizeSmallest = 100;
        for (int i : summationList) {
            if (i > typeSizeLargest) {
                typeSizeLargest = i;
            }
            if (i < typeSizeSmallest) {
                typeSizeSmallest = i;
            }
        }
        if (typeSizeLargest >= typeSizeSmallest * 3) {
            score -= typeSizeLargest * 160;
        }
        return score;
    }

    private Double simpleRNNMatrixCalculations(Double score, ArrayList<SimpleMatrix> simpleSMXlist1,
                                               ArrayList<SimpleMatrix> simpleSMXlist2) {
        List<Double> iteratedDoubleList = new ArrayList();
        List<Double> iterateddotPredictions = new ArrayList();
        double dotpredictionTransfer = 0.0;
        int iterationOverHeat = 0;
        double scoreFallback = score;
        for (SimpleMatrix simpleSMX2 : simpleSMXlist2) {
            ArrayList<Double> AccumulateDotList = new ArrayList<>();
            ArrayList<Double> subtractorList = new ArrayList<Double>();
            ArrayList<Double> dotPredictions = new ArrayList<Double>();
            ArrayList<Double> DotOverTransfer = new ArrayList<Double>();
            Double totalSubtraction = 0.0;
            Double largest = 10.0;
            Double shortest = 100.0;
            for (SimpleMatrix simpleSMX1 : simpleSMXlist1) {
                double dotPrediction2 = simpleSMX2.dot(simpleSMX1) * 100;
                double dotPrediction1 = simpleSMX1.dot(simpleSMX2) * 100;
                AccumulateDotList.add(dotPrediction1);
                AccumulateDotList.add(dotPrediction2);
                double subtracter1 = dotPrediction1 > 50 ? dotPrediction1 - 100 : dotPrediction1 > 0 ? 100 - dotPrediction1 : 0;
                double subtracter2 = dotPrediction2 > 50 ? dotPrediction2 - 100 : dotPrediction2 > 0 ? 100 - dotPrediction2 : 0;
                subtractorList.add(subtracter1);
                subtractorList.add(subtracter2);
                dotpredictionTransfer = dotPrediction1;
                if (!dotPredictions.contains(dotPrediction1)) {
                    for (Double transferDots : DotOverTransfer) {
                        if (transferDots == dotPrediction1) {
                            totalSubtraction += transferDots;
                        } else {
                            score -= subtracter1 * 25;
                        }
                    }
                    DotOverTransfer.add(dotPrediction1);
                } else {
                    subtracter1 -= 100;
                    subtracter1 *= 25;
                    score += subtracter1 * dotPrediction1;
                }
                dotPredictions.add(dotPrediction1);
                if (!dotPredictions.contains(dotPrediction2)) {
                    for (Double transferDots : DotOverTransfer) {
                        if (transferDots == dotPrediction2) {
                            totalSubtraction += transferDots;
                        } else {
                            score -= subtracter1 * 25;
                        }
                    }
                    DotOverTransfer.add(dotPrediction2);
                    if (dotPrediction2 > largest) {
                        largest = dotPrediction2;
                    }
                    if (dotPrediction2 < shortest) {
                        shortest = dotPrediction2;
                    }
                    Double dotPredictionIntervalDifference = largest - shortest;
                    subtracter2 *= 25;
                    if (dotPredictionIntervalDifference < 5.0) {
                        if (dotPredictions.size() > 0) {
                            if (subtracter2 > 0) {
                                score -= subtracter2;
                            } else {
                                score += subtracter2;
                            }
                        }
                    } else {
                        score -= subtracter2 / 10;
                    }
                } else {
                    if (subtracter2 > 55.0 && subtracter2 < 82.0) {
                        if (dotPrediction2 > 30 && dotPrediction2 < 60) {
                            if (dotpredictionTransfer != 0.0 && (subtracter2 / dotPrediction2 < 1.3 || (subtracter2 / dotPrediction2 > 1.9
                                    && subtracter2 / dotPrediction2 < 1.99))) {
                                if (subtracter2 / dotPrediction2 < 1.248 && subtracter2 / dotPrediction2 > 1.238) {
                                    score -= 2500;
                                } else {
                                    score += 4500;
                                }
                            } else if (dotpredictionTransfer != 0.0 && subtracter2 / dotPrediction2 > 1.6 && subtracter2 / dotPrediction2 < 1.95) {
                                if (subtracter2 > 61.1 && subtracter2 < 61.9 && dotPrediction2 > 37.5 && dotPrediction2 < 38.2) {
                                    score += 4500;
                                } else {
                                    score -= 4500;
                                }
                            } else if (!iterateddotPredictions.contains(dotPrediction2)) {
                                score += subtracter2 * dotPrediction2; // +=
                                iterateddotPredictions.add(dotPrediction2);
                            } else {
                                score -= 550;
                            }
                        } else if (dotPrediction2 < 25 && subtracter2 < 75) {
                            score -= dotPrediction2 * 250;
                        } else if (subtracter2 > 75.0) {
                            if (dotPrediction2 > 20.0 && dotPrediction2 < 23.0) {
                                score += 3500;
                            } else {
                                if (subtracter2 < 75.9 && dotPrediction2 > 24.0 && dotPrediction2 < 24.9) {
                                    score += (subtracter2 * dotPrediction2) * 5;
                                } else {
                                    score -= 4500;
                                }
                            }
                        }
                    }
                }
                dotPredictions.add(dotPrediction2);
                iterationOverHeat++;
            }
            Double subTracPre = 0.0;
            for (Double subtractors : subtractorList) {
                if (Objects.equals(subTracPre, subtractors)) {
                    if (subTracPre > 43.5 && subTracPre < 50.0) {
                        score += (subTracPre * 15) / subtractorList.size();
                    } else if (subTracPre > 60.0 && subTracPre < 66.5) {
                        score += (subTracPre * 15) / subtractorList.size();
                    }
                } else if (subTracPre > 75.0 && subTracPre < 90.0) {
                    score += (subTracPre * 50) / subtractorList.size();
                } else if (subTracPre >= 55.0) {
                    score -= 2800;
                } else if (subTracPre < -25.0 && subTracPre > -45.0) {
                    score += subTracPre * 100;
                }
                subTracPre = subtractors;
            }
            if (totalSubtraction > 45.0) {
                score -= totalSubtraction * 25;
            } else {
                score += totalSubtraction * 25;
            }
            Double preAccumulatorDot = 0.0;
            Double postAccumulatorDot = 0.0;
            for (Double accumulators : AccumulateDotList) {
                if (Objects.equals(preAccumulatorDot, accumulators)) {
                    if (Objects.equals(postAccumulatorDot, accumulators)) {
                        score -= 1400;
                    }
                    postAccumulatorDot = accumulators;
                }
                preAccumulatorDot = accumulators;
            }
            subTracPre = 0.0;
            for (Double subtractors : subtractorList) {
                if (Objects.equals(subTracPre, subtractors) && subTracPre != 0.0) {
                    if (!iteratedDoubleList.contains(subTracPre)) {
                        score += 500;
                        iteratedDoubleList.add(subTracPre);
                    } else {
                        score -= 150;
                    }
                }
                subTracPre = subtractors;
            }
        }
        if (iterationOverHeat > 12) {
            score = scoreFallback;
            score -= 2500;
        }
        return score;
    }

    private Double simpleRNNMaxtrixVectors(Double score, ArrayList<SimpleMatrix> simpleSMXlistVector1, ArrayList<SimpleMatrix> simpleSMXlistVector2) {
        ArrayList<Double> elementSumCounter = new ArrayList<>();
        ArrayList<Double> dotMap = new ArrayList<>();
        ArrayList<Double> elementSumMap = new ArrayList<>();
        ArrayList<Double> dotSumMap = new ArrayList<>();
        Double preDot = 0.0;
        Double postDot = 0.0;
        int iterateSize = simpleSMXlistVector1.size() + simpleSMXlistVector2.size();
        for (SimpleMatrix simpleSMX2 : simpleSMXlistVector2) {
            for (SimpleMatrix simpleSMX1 : simpleSMXlistVector1) {
                double dot2 = simpleSMX2.dot(simpleSMX1);
                double elementSum2 = simpleSMX2.kron(simpleSMX1).elementSum();
                double dot1 = simpleSMX1.dot(simpleSMX2);
                double elementSum1 = simpleSMX1.kron(simpleSMX2).elementSum();
                if (preDot == dot2) {
                    if (postDot == dot2) {
                        score -= 500;
                    }
                    postDot = dot2;
                }
                if (preDot == dot1) {
                    if (postDot == dot1) {
                        score -= 500;
                    }
                    postDot = dot1;
                }
                preDot = dot1;
                elementSum1 = Math.round(elementSum1 * 100.0) / 100.0;
                elementSumCounter.add(elementSum1);
                dotMap.add(dot1);
                preDot = dot2;
                elementSum2 = Math.round(elementSum2 * 100.0) / 100.0;
                elementSumCounter.add(elementSum2);
                dotMap.add(dot2);
                if (!dotSumMap.contains(dot1)) {
                    if (dot1 < 0.1 && dot1 > 0.050) {
                        score += 256;
                    }
                    if (dot1 > 0.44 && dot1 < 0.60) {
                        score -= 2400;
                    } else if (dot1 > 0.40 && dot1 < 0.445) {
                        score += 3600;
                    }
                    dotSumMap.add(dot1);
                } else {
                    score -= 50;
                }
                if (!elementSumMap.contains(elementSum1)) {
                    if (elementSum1 < 0.01 && elementSum1 > 0.00) {
                        score += 1300;
                    } else if (elementSum1 > 0.1 && elementSum1 < 1.0) {
                        score += 1100;
                    } else {
                        score -= elementSum1 * 1024;
                    }
                    elementSumMap.add(elementSum1);
                } else {
                    score -= 50;
                }
                if (!dotSumMap.contains(dot2)) {
                    if (dot2 < 0.000) {
                        score += dot2 * 500;
                    } else if (dot2 < 0.1) {
                        score += 256;
                    }
                    if (dot2 > 0.50) {
                        score -= 1200;
                    }
                    dotSumMap.add(dot2);
                } else if (dot2 > 0.050 && dot2 < 0.10) {
                    score -= 350;
                } else {
                    score = score > 0 ? score - dot2 * 1200 : score + dot2 * 1200;
                }
                if (!elementSumMap.contains(elementSum2)) {
                    if (elementSum2 < 0.01 && elementSum2 > 0.00) {
                        score += 3300;
                    } else if (elementSum2 > 0.1 && elementSum2 < 0.2) {
                        score += 1100;
                    } else {
                        score -= elementSum2 * 1024;
                    }
                    elementSumMap.add(elementSum2);
                } else if (elementSum2 > 0.050 && elementSum2 < 0.10) {
                    score += 750;
                } else {
                    score = score > 0 ? score - elementSum2 * 1200 : score + elementSum2 * 1200;
                }
            }
        }
        if (iterateSize > 5) {
            score -= iterateSize * 400;
        }
        score = elementsAndDotsRelation(score, dotMap, elementSumCounter);
        return score;
    }

    private Double elementsAndDotsRelation(Double score, ArrayList<Double> dotMap, ArrayList<Double> elementSumCounter) {
        OptionalDouble minvalueDots = dotMap.stream().mapToDouble(Double::doubleValue).min();
        OptionalDouble maxvalueDots = dotMap.stream().mapToDouble(Double::doubleValue).max();
        boolean permitted = false;
        if (minvalueDots.getAsDouble() != maxvalueDots.getAsDouble()) {
            permitted = true;
        }
        if (permitted) {
            Double dotsVariance = maxvalueDots.getAsDouble() - minvalueDots.getAsDouble();
            if (maxvalueDots.getAsDouble() > minvalueDots.getAsDouble() * 10 && (dotsVariance < 0.40
                    || dotsVariance > 0.60)) {
                score -= 5500;
            } else if (minvalueDots.getAsDouble() < -0.10) {
                score -= 3500;
            } else if (dotsVariance > minvalueDots.getAsDouble() * 2) {
                score += 3500;
            } else if (minvalueDots.getAsDouble() * 2 > maxvalueDots.getAsDouble()) {
                score -= 3500;
            }
        }
        OptionalDouble minvalueElements = elementSumCounter.stream().mapToDouble(Double::doubleValue).min();
        OptionalDouble maxvalueElements = elementSumCounter.stream().mapToDouble(Double::doubleValue).max();
        Double elementsVariance = maxvalueElements.getAsDouble() - minvalueElements.getAsDouble();
        if (elementsVariance != 0.0) {
            if (elementsVariance <= 0.01 && maxvalueElements.getAsDouble() <= 0.02) {
                if (maxvalueElements.getAsDouble() < 0.01 && minvalueElements.getAsDouble() > -0.02 && minvalueElements.getAsDouble() < 0.0) {
                    score += 6500;
                } else {
                    score -= 5500;
                }
            } else if (minvalueElements.getAsDouble() < 0.0 && minvalueElements.getAsDouble() - maxvalueElements.getAsDouble() < 0.50) {
                score -= 4500;
            } else if (elementsVariance * 2 >= maxvalueElements.getAsDouble() && elementsVariance < 0.1) {
                score -= elementsVariance * 86000;
            }
        } else if (maxvalueElements.getAsDouble() == minvalueElements.getAsDouble() && maxvalueElements.getAsDouble() > 0.40
                && maxvalueElements.getAsDouble() < 0.60) {
            score += 600;
        } else if (maxvalueElements.getAsDouble() < 0.20 && minvalueElements.getAsDouble() >= 0.15) {
            score += 2600;
        } else if (maxvalueElements.getAsDouble() == minvalueElements.getAsDouble() && minvalueElements.getAsDouble() == 0.12) {
            score += 2600;
        }
        return score;
    }

    private Double sentimentMatrixVariances(Double score, int longest1, int longest2, int mainSentiment1, int mainSentiment2) {
        if (longest1 != longest2) {
            long deffLongest = longest1 > longest2 ? longest1 : longest2;
            long deffshorter = longest1 < longest2 ? longest1 : longest2;
            if (deffLongest > deffshorter * 5) {
                score -= 5500;
            } else if (deffLongest < (deffshorter * 2) - 1 && deffLongest - deffshorter <= 45) {
                score += (deffLongest - deffshorter) * 20;
            } else if (mainSentiment1 != mainSentiment2 && deffLongest - deffshorter > 20 && deffLongest - deffshorter < 45) {
                score += (deffLongest - deffshorter) * 20;
            } else if (deffLongest - deffshorter < 2) {
                score += (deffLongest - deffshorter) * 20;
            } else if (deffshorter * 2 >= deffLongest && deffshorter * 2 < deffLongest + 5) {
                score += (deffLongest - deffshorter) * 20;
            } else {
                score -= (deffLongest - deffshorter) * 50;
            }
            if (deffLongest - deffshorter <= 5) {
                if (deffLongest < 24 && deffshorter > 20) {
                    score += 4500;
                } else if (deffLongest - deffshorter == 5 && deffshorter >= 19 && deffLongest <= 24) {
                    score += 4500;
                } else {
                    if (deffshorter > 26 && deffLongest < 35) {
                        score += 3900;
                    } else if (deffLongest - deffshorter == 1 && deffshorter > 15 && deffLongest < 25) {
                        score += 4900;
                    } else {
                        score -= 1900;
                    }
                }
            }
        }
        return score;
    }

    private int classifyRawEvaluation() {
        DocumentReaderAndWriter<CoreLabel> readerAndWriter = classifier.makePlainTextReaderAndWriter();
        List list1 = classifier.classifyRaw(str, readerAndWriter);
        List list2 = classifier.classifyRaw(str1, readerAndWriter);
        final List classifyRaw1 = list1;
        final List classifyRaw2 = list2;
        return (classifyRaw1.size() > classifyRaw2.size() ? classifyRaw1.size() - classifyRaw2.size() : classifyRaw2.size() - classifyRaw1.size()) * 200;
    }

    private Double entryCountsRelation(Double score, ArrayList<Integer> cacheSentimentLocal1, ArrayList<Integer> cacheSentimentLocal2) {
        int entry1 = cacheSentimentLocal1.size();
        int entry2 = cacheSentimentLocal2.size();
        if (entry1 > 0 && entry2 > 0) {
            if ((entry1 >= entry2 * 5) || (entry2 >= entry1 * 5)) {
                score -= entry1 > entry2 ? (entry1 - entry2) * 450 : (entry2 - entry1) * 450;
            } else if ((entry1 >= entry2 * 50 || entry2 >= entry1 * 50)) {
                score -= entry1 > entry2 ? entry1 * 180 : entry2 * 180;
            } else if ((entry1 >= entry2 * 2 || entry2 >= entry1 * 2) && entry1 * 2 >= entry2 && entry2 * 2 >= entry1) {
                score -= entry1 > entry2 ? (entry1 - entry2) * 450 : (entry2 - entry1) * 450;
            } else if (entry1 * 3 >= entry2 && entry2 * 3 >= entry1) {
                score -= entry1 > entry2 ? (entry1 - entry2) * 550 : (entry2 - entry1) * 550;
            } else if (entry1 > 10 && entry2 > 10 && entry1 * 2 > entry2 && entry2 * 2 > entry1) {
                score += entry1 > entry2 ? entry2 * 600 : entry1 * 600;
            }
        }
        return score;
    }

    private ArrayList<TypedDependency> grammaticalStructureAllTypedDependencies(
            ArrayList<GrammaticalStructure> grammaticalStructures) {
        ArrayList<TypedDependency> typedDependenciesArr = new ArrayList<>();
        for (GrammaticalStructure gs : grammaticalStructures) {
            Collection<TypedDependency> typedDependencies = gs.allTypedDependencies();
            typedDependenciesArr.addAll(typedDependencies);
        }
        return typedDependenciesArr;
    }

    private ArrayList<GrammaticalStructure> grammaticalStructureSetup(ArrayList<Tree> trees) {
        ArrayList<GrammaticalStructure> grammaticalStructures = new ArrayList<GrammaticalStructure>();
        for (Tree tree : trees) {
            GrammaticalStructure gs = gsf.newGrammaticalStructure(tree);
            grammaticalStructures.add(gs);
        }
        return grammaticalStructures;
    }

    private ArrayList<Tree> retrieveTrees(List<CoreMap> sentences) {
        ArrayList<Tree> treeList = new ArrayList<Tree>();
        for (CoreMap sentence : sentences) {
            Tree sentenceConstituencyParse = sentence.get(TreeCoreAnnotations.TreeAnnotation.class);
            treeList.add(sentenceConstituencyParse);
        }
        return treeList;
    }

    private ArrayList<SimpleMatrix> sentimentRNNCorePredicted(List<CoreMap> sentences,
                                                              Class<SentimentCoreAnnotations.SentimentAnnotatedTree> sentimentAnnotatedTreeClass) {
        ArrayList<SimpleMatrix> rnnCoreAnnotationsPrediction = new ArrayList<>();
        for (CoreMap sentence : sentences) {
            Tree tree = sentence.get(sentimentAnnotatedTreeClass);
            if (tree != null) {
                SimpleMatrix predictions = RNNCoreAnnotations.getPredictions(tree);
                rnnCoreAnnotationsPrediction.add(predictions);
            }
        }
        return rnnCoreAnnotationsPrediction;
    }

    private ArrayList<SimpleMatrix> sentimentRNNCoreNodevectors(List<CoreMap> sentences,
                                                                Class<SentimentCoreAnnotations.SentimentAnnotatedTree> sentimentAnnotatedTreeClass) {
        ArrayList<SimpleMatrix> rnnCoreAnnotationsNodevectors = new ArrayList<>();
        for (CoreMap sentence : sentences) {
            Tree tree = sentence.get(sentimentAnnotatedTreeClass);
            if (tree != null) {
                SimpleMatrix nodeVector = RNNCoreAnnotations.getNodeVector(tree);
                rnnCoreAnnotationsNodevectors.add(nodeVector);
            }
        }
        return rnnCoreAnnotationsNodevectors;
    }

    private ArrayList<Integer> sentimentRNNCoreAnnotations(List<CoreMap> sentences,
                                                           Class<SentimentCoreAnnotations.SentimentAnnotatedTree> sentimentAnnotatedTreeClass) {
        ArrayList<Integer> rnnCoreAnnotationsPredicted = new ArrayList<>();
        for (CoreMap sentence : sentences) {
            Tree tree = sentence.get(sentimentAnnotatedTreeClass);
            if (tree != null) {
                int predictedClass = RNNCoreAnnotations.getPredictedClass(tree);
                rnnCoreAnnotationsPredicted.add(predictedClass);
            }
        }
        return rnnCoreAnnotationsPredicted;
    }

    private int setupMainSentiment(List<CoreMap> sentences4,
                                   Class<SentimentCoreAnnotations.SentimentAnnotatedTree> sentimentAnnotatedTreeClass) {
        int longest = 0;
        int longestSentiment = 0;
        for (CoreMap sentence : sentences4) {
            Tree tree = sentence.get(sentimentAnnotatedTreeClass);
            int sentiment = RNNCoreAnnotations.getPredictedClass(tree);
            String partText = sentence.toString();
            if (partText.length() > longest) {
                longestSentiment = sentiment;
                longest = partText.length();
            }
        }
        return longestSentiment;
    }

    private int setupMainLongest(List<CoreMap> sentences) {
        int longest = 0;
        for (CoreMap sentence : sentences) {
            String partText = sentence.toString();
            if (partText.length() > longest) {
                longest = partText.length();
            }
        }
        return longest;
    }

    private Double entryCountsScoring(Double score, ArrayList<Integer> cacheSentimentLocal1, ArrayList<Integer> cacheSentimentLocal2) {
        ArrayList<Integer> countsMap = new ArrayList<Integer>();
        int totalsize = cacheSentimentLocal1.size() + cacheSentimentLocal2.size();
        for (int counts : cacheSentimentLocal1) {
            for (int counts1 : cacheSentimentLocal2) {
                if (counts > 0 && counts1 > 0) {
                    if (counts == counts1 && !countsMap.contains(counts)) {
                        score += (counts * 250) / totalsize;
                        countsMap.add(counts);
                    } else if (counts * 3 < counts1 || counts1 * 3 < counts) {
                        score -= 600;
                    }
                }
            }
        }
        return score;
    }

    private Double tokenEntryPosScoring(Double score, ArrayList<String> cacheSentimentLocal1, ArrayList<String> cacheSentimentLocal2) {
        if (cacheSentimentLocal1.size() > 1 && cacheSentimentLocal2.size() > 1) {
            for (String strTokenPos1 : cacheSentimentLocal1) {
                for (String strTokenPos2 : cacheSentimentLocal2) {
                    if (strTokenPos1.equals(strTokenPos2)) {
                        score += 500;
                    }
                }
            }
            int posEntrySize1 = cacheSentimentLocal1.size();
            int posEntrySize2 = cacheSentimentLocal2.size();
            if (posEntrySize1 * 3 > posEntrySize2 && posEntrySize2 * 3 > posEntrySize1) {
                score += posEntrySize1 > posEntrySize2 ? (posEntrySize1 - posEntrySize2) * 700 : (posEntrySize2 - posEntrySize1) * 700;
            }
        }
        return score;
    }

    private Double unmarkedPatternCounterScoring(Double score, int UnmarkedPatternCounter1, int UnmarkedPatternCounter2) {
        if (UnmarkedPatternCounter1 > 0 && UnmarkedPatternCounter2 > 0) {
            if (UnmarkedPatternCounter1 < 100 && UnmarkedPatternCounter2 < 100) {
                if (UnmarkedPatternCounter1 * 2 > UnmarkedPatternCounter2 && UnmarkedPatternCounter2 * 2 > UnmarkedPatternCounter1) {
                    score += 2500;
                } else if (UnmarkedPatternCounter1 * 5 < UnmarkedPatternCounter2 || UnmarkedPatternCounter2 * 5 < UnmarkedPatternCounter1) {
                    score -= 4000;
                }
            } else if (UnmarkedPatternCounter1 > 500 && UnmarkedPatternCounter2 > 500) {
                score -= UnmarkedPatternCounter1 >= UnmarkedPatternCounter2 ? UnmarkedPatternCounter1 * 3 : UnmarkedPatternCounter2 * 3;
            }
        }
        return score;
    }

    private Double markedContiniousCounterScoring(Double score, int MarkedContinuousCounter1, int MarkedContinuousCounter2) {
        int MarkedContiniousCounter1Entries = MarkedContinuousCounter1;
        int MarkedContiniousCounter2Entries = MarkedContinuousCounter2;
        if (MarkedContinuousCounter1 > 0 && MarkedContinuousCounter2 > 0) {
            if (MarkedContinuousCounter1 > MarkedContinuousCounter2 * 50 || MarkedContinuousCounter2 > MarkedContinuousCounter1 * 50) {
                score -= MarkedContinuousCounter1 > MarkedContinuousCounter2 ? MarkedContinuousCounter1 * 120 : MarkedContinuousCounter2 * 120;
            } else if (!Objects.equals(MarkedContiniousCounter1Entries, MarkedContiniousCounter2Entries)
                    && (MarkedContinuousCounter1 * 2 >= MarkedContinuousCounter2 * MarkedContinuousCounter1)
                    || (MarkedContinuousCounter2 * 2 >= MarkedContinuousCounter1 * MarkedContinuousCounter2)) {
                score += 4500;
            } else if (MarkedContiniousCounter1Entries == 0 || MarkedContiniousCounter2Entries == 0) {
                score += MarkedContinuousCounter1 > MarkedContinuousCounter2 ? (MarkedContinuousCounter2 - MarkedContinuousCounter1) * 500
                        : (MarkedContinuousCounter1 - MarkedContinuousCounter2) * 500;
            }
            if (MarkedContiniousCounter1Entries > 0 && MarkedContiniousCounter2Entries > 0 && MarkedContinuousCounter1 > 0
                    && MarkedContinuousCounter2 > 0 && MarkedContinuousCounter1 < MarkedContinuousCounter2 * 10
                    && MarkedContinuousCounter2 < MarkedContinuousCounter1 * 10) {
                if (MarkedContiniousCounter1Entries > MarkedContiniousCounter2Entries * 5
                        || MarkedContiniousCounter2Entries > MarkedContiniousCounter1Entries * 5
                        || MarkedContiniousCounter1Entries * 5 < MarkedContinuousCounter1
                        || MarkedContiniousCounter1Entries * 5 < MarkedContinuousCounter2
                        || MarkedContiniousCounter2Entries * 5 < MarkedContinuousCounter1
                        || MarkedContiniousCounter2Entries * 5 < MarkedContinuousCounter2) {
                    score -= MarkedContinuousCounter1 > MarkedContinuousCounter2 ? MarkedContinuousCounter1 * 400 : MarkedContinuousCounter2 * 400;
                }
            }
        }
        return score;
    }

    private Double strTokensMapScoring(Double score, ArrayList<String> cacheSentimentLocal1, ArrayList<String> cacheSentimentLocal2) {
        ArrayList<String> strtokensMap = new ArrayList<String>();
        for (String strTokeniPart1 : cacheSentimentLocal1) {
            for (String strTokeniPart2 : cacheSentimentLocal2) {
                if (strTokeniPart1.equals(strTokeniPart2) && !strtokensMap.contains(strTokeniPart2)) {
                    strtokensMap.add(strTokeniPart2);
                    score += 800;
                }
            }
        }
        int tokenIPartSize1 = cacheSentimentLocal1.size();
        int tokenIPartSize2 = cacheSentimentLocal2.size();
        int strTokenMapSize = strtokensMap.size();
        if (tokenIPartSize1 * 2 > tokenIPartSize2 && tokenIPartSize2 * 2 > tokenIPartSize1) {
            score += tokenIPartSize1 > tokenIPartSize2 ? (tokenIPartSize1 - tokenIPartSize2) * 700 : (tokenIPartSize2 - tokenIPartSize1) * 700;
            score += strTokenMapSize * 600;
        } else if (tokenIPartSize1 > 0 && tokenIPartSize2 > 0) {
            score -= tokenIPartSize1 > tokenIPartSize2 ? (tokenIPartSize1 - tokenIPartSize2) * 700 : (tokenIPartSize2 - tokenIPartSize1) * 700;
        }
        return score;
    }

    private Double strTokenEntryScoring(Double score, ArrayList<String> cacheSentimentLocal1, ArrayList<String> cacheSentimentLocal2) {
        int tokenEntry1 = cacheSentimentLocal1.size();
        int tokenEntry2 = cacheSentimentLocal2.size();
        boolean boundaryLeaks = false;
        int remnantCounter = 0;
        if (tokenEntry1 * 2 != tokenEntry2 && tokenEntry2 * 2 != tokenEntry1) {
            boundaryLeaks = true;
        }
        ArrayList<String> entryTokenMap = new ArrayList<String>();
        for (String strTokenEntry1 : cacheSentimentLocal1) {
            for (String strTokenEntry2 : cacheSentimentLocal2) {
                if (!entryTokenMap.contains(strTokenEntry2)) {
                    if (strTokenEntry1.equals(strTokenEntry2)) {
                        score += boundaryLeaks ? 2500 : 2500 / 2;
                    } else if (!boundaryLeaks) {
                        score -= 450;
                    } else {
                        remnantCounter++;
                    }
                }
                entryTokenMap.add(strTokenEntry2);
            }
        }
        score += remnantCounter * 250;
        return score;
    }

    private Double strTokenMapTagsScoring(Double score, ArrayList<String> cacheSentimentLocal1, ArrayList<String> cacheSentimentLocal2) {
        ArrayList<String> iTokenMapTagsMap = new ArrayList<String>();
        for (String strmapTag : cacheSentimentLocal1) {
            for (String strmapTag1 : cacheSentimentLocal2) {
                if (strmapTag.equals(strmapTag1) && !iTokenMapTagsMap.contains(strmapTag1)) {
                    score -= 1450;
                    iTokenMapTagsMap.add(strmapTag);
                }
            }
        }
        int mapTagsize1 = cacheSentimentLocal1.size();
        int mapTagsize2 = cacheSentimentLocal2.size();
        int tokenTagMapSize = iTokenMapTagsMap.size();
        if (mapTagsize1 != 0 && mapTagsize2 != 0) {
            if (mapTagsize1 * 2 > mapTagsize2 && mapTagsize2 * 2 > mapTagsize1) {
                score += mapTagsize1 > mapTagsize2 ? (mapTagsize1 - mapTagsize2) * 700 : (mapTagsize2 - mapTagsize1) * 700;
                score += tokenTagMapSize * 600;
            } else {
                score -= mapTagsize1 > mapTagsize2 ? (mapTagsize1 - mapTagsize2) * 700 : (mapTagsize2 - mapTagsize1) * 700;
            }
        }
        return score;
    }

    private Double tokenformSizeScoring(Double score, ArrayList<String> cacheSentimentLocal1, ArrayList<String> cacheSentimentLocal2) {
        int tokenform1size = cacheSentimentLocal1.size();
        int tokenform2size = cacheSentimentLocal2.size();
        if (tokenform1size > 0 || tokenform2size > 0) {
            if (tokenform1size < tokenform2size * 5 && tokenform2size < tokenform1size * 5) {
                for (String strTokenForm1itr1 : cacheSentimentLocal1) {
                    for (String strTokenForm1itr2 : cacheSentimentLocal2) {
                        if (strTokenForm1itr1.equals(strTokenForm1itr2)) {
                            score -= 1600;
                        } else {
                            score += 500;
                        }
                    }
                }
            } else if (tokenform1size > 0 && tokenform2size > 0) {
                if (tokenform1size * 2 >= tokenform2size && tokenform2size * 2 >= tokenform1size) {
                    score += tokenform1size > tokenform2size ? tokenform1size * 600 : tokenform2size * 600;
                } else if (tokenform1size * 4 <= tokenform2size || tokenform2size * 4 <= tokenform1size) {
                    score -= tokenform1size > tokenform2size ? (tokenform1size - tokenform2size) * 600 : (tokenform2size - tokenform1size) * 600;
                }
            }
        }
        return score;
    }

    private Double tokenStemmingMapScoring(Double score, ArrayList<String> cacheSentimentLocal1, ArrayList<String> cacheSentimentLocal2) {
        ArrayList<String> tokenStemmingMap = new ArrayList<String>();
        for (String strTokenStem : cacheSentimentLocal1) {
            for (String strTokenStem1 : cacheSentimentLocal2) {
                if (strTokenStem.equals(strTokenStem1) && !tokenStemmingMap.contains(strTokenStem)) {
                    score += 500;
                    tokenStemmingMap.add(strTokenStem);
                }
            }
        }
        return score;
    }

    private Double inflectedCounterScoring(Double score, int inflectedCounterPositive1, int inflectedCounterPositive2,
                                           int inflectedCounterNegative1, int inflectedCounterNegative2) {
        int inflectedCounterNegative = inflectedCounterNegative1 > inflectedCounterNegative1
                ? inflectedCounterNegative1 - inflectedCounterNegative2
                : inflectedCounterNegative2 - inflectedCounterNegative1;
        if ((inflectedCounterPositive1 + inflectedCounterPositive2) > inflectedCounterNegative && inflectedCounterNegative > 0) {
            score += ((inflectedCounterPositive1 + inflectedCounterPositive2) - inflectedCounterNegative) * 650;
        }
        if (inflectedCounterPositive1 > 0 && inflectedCounterPositive2 > 0) {
            if (inflectedCounterPositive1 * 2 > inflectedCounterPositive2 && inflectedCounterPositive2 * 2 > inflectedCounterPositive1
                    && inflectedCounterNegative > 0) {
                score += ((inflectedCounterPositive1 + inflectedCounterPositive2) * 150) - (inflectedCounterNegative * 10);
            } else if (inflectedCounterPositive1 * 5 < inflectedCounterPositive2 || inflectedCounterPositive2 * 5 < inflectedCounterPositive1) {
                score -= inflectedCounterPositive1 > inflectedCounterPositive2 ? (inflectedCounterPositive1 - inflectedCounterPositive2) * 400
                        : (inflectedCounterPositive2 - inflectedCounterPositive1) * 400;
            }
        }
        if (inflectedCounterPositive1 >= 15 && inflectedCounterPositive2 >= 15) {
            score -= 4000;
        }
        return score;
    }

    private Double annotatorCountScoring(Double score, int anotatorcounter1, int anotatorcounter2) {
        if (anotatorcounter1 > 1 && anotatorcounter2 > 1) {
            if (anotatorcounter1 * 2 > anotatorcounter2 && anotatorcounter2 * 2 > anotatorcounter1) {
                score += anotatorcounter1 > anotatorcounter2 ? (anotatorcounter1 - anotatorcounter2) * 700
                        : (anotatorcounter2 - anotatorcounter1) * 700;
            } else if (anotatorcounter1 * 5 < anotatorcounter2 || anotatorcounter2 * 5 < anotatorcounter1) {
                score -= anotatorcounter1 > anotatorcounter2 ? (anotatorcounter1 - anotatorcounter2) * 400 : (anotatorcounter2 - anotatorcounter1) * 400;
            }
        }
        return score;
    }

    private Double tokensCounterScoring(Double score, int tokensCounter1, int tokensCounter2) {
        if ((tokensCounter1 > 1 && tokensCounter2 > 1) && tokensCounter1 < tokensCounter2 * 5 && tokensCounter2 < tokensCounter1 * 5) {
            if (tokensCounter1 > tokensCounter2 / 2 && tokensCounter2 > tokensCounter1 / 2 && tokensCounter1 < 10 && tokensCounter2 < 10) {
                score += (tokensCounter1 + tokensCounter2) * 500;
            } else {
                score -= 500;
            }
        } else {
            int elseint = tokensCounter1 >= tokensCounter2 ? (tokensCounter1 - tokensCounter2) * 500 : (tokensCounter2 - tokensCounter1) * 500;
            if ((tokensCounter1 > tokensCounter2 * 5 || tokensCounter2 > tokensCounter1 * 5)
                    && tokensCounter1 > 0 && tokensCounter2 > 0) {
                score -= tokensCounter1 > tokensCounter2 ? (tokensCounter1 - tokensCounter2) * 500 : (tokensCounter2 - tokensCounter1) * 500;
            } else if (elseint > 0 && tokensCounter1 > 0 && tokensCounter2 > 0) {
                if (elseint > 500 && elseint < 2000) {
                    score += elseint * 10;
                } else {
                    score -= elseint * 15;
                }
            } else {
                if (elseint > 0 && elseint < 1500 && (tokensCounter1 > 0 || tokensCounter2 > 0) && tokensCounter1 <= 2 && tokensCounter2 <= 2) {
                    score -= elseint * 1.5;
                } else if (tokensCounter1 < 5 && tokensCounter2 < 5) {
                    score -= elseint * (tokensCounter1 + tokensCounter2);
                }
            }
        }
        return score;
    }

    private Double nerEntitiesAndTokenScoring(Double score, ArrayList<String> entityTokenTags1,
                                              ArrayList<String> entityTokenTags2, ArrayList<String> nerEntities1,
                                              ArrayList<String> nerEntities2) {
        List<String> entsCollection = new ArrayList();
        for (String strEnts1 : nerEntities1) {
            for (String strEnts2 : nerEntities2) {
                if (strEnts1.equalsIgnoreCase(strEnts2) && !entsCollection.contains(strEnts1)) {
                    score += 2500;
                    entsCollection.add(strEnts1);
                }
            }
        }
        entsCollection = new ArrayList();
        for (String strToken : entityTokenTags1) {
            for (String strToken1 : entityTokenTags2) {
                if (strToken.equalsIgnoreCase(strToken1) && !entsCollection.contains(strToken)) {
                    score += 2000;
                    entsCollection.add(strToken);
                }
            }
        }
        return score;
    }

    private Double stopWordTokenLemmaScoring(Double score, ArrayList<String> stopWordToken1,
                                             ArrayList<String> stopWordToken2, ArrayList<String> stopWordLemma1,
                                             ArrayList<String> stopWordLemma2) {
        Collection<String> stopWordCollection = new ArrayList();
        for (String stopwords1 : stopWordToken1) {
            for (String stopwords2 : stopWordToken2) {
                if (stopwords1.equals(stopwords2) && !stopWordCollection.contains(stopwords1)) {
                    score -= 50;
                    stopWordCollection.add(stopwords1);
                }
            }
        }
        stopWordCollection = new ArrayList();
        for (String stopwords1 : stopWordLemma1) {
            for (String stopwords2 : stopWordLemma2) {
                if (stopwords1.equals(stopwords2) && !stopWordCollection.contains(stopwords1)) {
                    score -= 50;
                    stopWordCollection.add(stopwords1);
                }
            }
        }
        return score;
    }

    private Double stopwordTokenPairCounterScoring(Double score, ArrayList<String> stopWordToken1,
                                                   ArrayList<String> stopWordToken2, int pairCounter1,
                                                   int pairCounter2) {
        if (!stopWordToken1.isEmpty() && !stopWordToken1.isEmpty()) {
            int stopwordsize1 = stopWordToken1.size();
            int stopwordsize2 = stopWordToken1.size();
            if (stopwordsize1 * 5 < stopwordsize2 || stopwordsize2 * 5 < stopwordsize1) {
                score -= stopwordsize1 > stopwordsize2 ? (stopwordsize1 - stopwordsize2) * 850 : (stopwordsize2 - stopwordsize1) * 850;
            } else if (stopwordsize1 == stopwordsize2 && stopwordsize1 > 1) {
                score -= stopwordsize1 * 450;
            } else if ((stopwordsize1 / 2 == stopwordsize2 || stopwordsize2 / 2 == stopwordsize1) && stopwordsize1 + stopwordsize2 >= 4) {
                score -= 2500;
            } else {
                score += stopwordsize1 > stopwordsize2 ? (stopwordsize1 - stopwordsize2) * 850 : (stopwordsize2 - stopwordsize1) * 850;
            }
        }
        if (pairCounter1 > 0 && pairCounter2 > 0) {
            if (pairCounter1 * 5 <= pairCounter2 || pairCounter2 * 5 <= pairCounter1) {
                score -= pairCounter1 > pairCounter2 ? (pairCounter1 - pairCounter2) * 1500 : (pairCounter2 - pairCounter1) * 1500;
            } else if (pairCounter1 == pairCounter2 && pairCounter1 > 1) {
                score -= pairCounter1 * 450;
            } else if ((pairCounter1 / 2 == pairCounter2 || pairCounter2 / 2 == pairCounter1) && pairCounter1 + pairCounter2 >= 4) {
                score -= 2500;
            } else {
                score += pairCounter1 > pairCounter2 ? (pairCounter1 - pairCounter2) * 700 : (pairCounter2 - pairCounter1) * 700;
            }
        }
        return score;
    }

    private Double tgwListScoreIncrementer(Double score, ArrayList<String> tgwListIndex1,
                                           ArrayList<String> tgwListIndex2) {
        int runCount = 0;
        for (String taggedWord : tgwListIndex1) {
            boolean found = false;
            for (String taggedWord1 : tgwListIndex2) {
                if (taggedWord.equals(taggedWord1)) {
                    found = true;
                    break;
                }
            }
            if (!found) {
                runCount++;
            }
        }
        score += runCount * 64;
        return score;
    }

    public void validateStringCaches() {
        if (this.tokenizeCountingF == null) {
            this.tokenizeCountingF = tokenizeCounting(getTaggedWordList(str1));
        }
        if (this.tokenizeCounting == null) {
            this.tokenizeCounting = tokenizeCounting(getTaggedWordList(str));
        }
        if (this.taggedWordListF == null) {
            this.taggedWordListF = getTaggedWordList(str);
        }
        if (this.taggedWordList1 == null) {
            this.taggedWordList1 = getTaggedWordList(str1);
        }
        if (this.retrieveTGWListF == null) {
            this.retrieveTGWListF = retrieveTGWListIndex(this.taggedWordListF);
        }
        if (this.retrieveTGWList1 == null) {
            this.retrieveTGWList1 = retrieveTGWListIndex(this.taggedWordList1);
        }
        if (this.sentencesF == null) {
            this.sentencesF = pipelineAnnotation1.get(CoreAnnotations.SentencesAnnotation.class);
        }
        if (this.sentences1 == null) {
            this.sentences1 = pipelineAnnotation2.get(CoreAnnotations.SentencesAnnotation.class);
        }
        if (this.sentencesSentimentF == null) {
            this.sentencesSentimentF = pipelineAnnotation1Sentiment.get(CoreAnnotations.SentencesAnnotation.class);
        }
        if (this.sentencesSentiment1 == null) {
            this.sentencesSentiment1 = pipelineAnnotation2Sentiment.get(CoreAnnotations.SentencesAnnotation.class);
        }
        if (this.treesF == null) {
            this.treesF = retrieveTrees(this.sentencesF);
        }
        if (this.trees1 == null) {
            this.trees1 = retrieveTrees(this.sentences1);
        }
    }


    public SimilarityMatrix callSMX() {
        Double score = -100.0;
        int counter1;
        int counter2;
        validateStringCaches();
        counter1 = this.tokenizeCountingF;
        counter2 = this.tokenizeCounting;
        final int overValue = (counter1 >= counter2 ? counter1 - counter2 : counter2 - counter1) * 32;
        score -= overValue;
        score = tgwListScoreIncrementer(score, this.retrieveTGWListF, this.retrieveTGWList1);
        Class<SentimentCoreAnnotations.SentimentAnnotatedTree> sentimentAnnotatedTreeClass =
                SentimentCoreAnnotations.SentimentAnnotatedTree.class;

        ArrayList<GrammaticalStructure> grammaticalStructures1 = grammaticalStructureSetup(this.treesF);
        ArrayList<GrammaticalStructure> grammaticalStructures2 = grammaticalStructureSetup(this.trees1);
        ArrayList<TypedDependency> typedDependencies1 = grammaticalStructureAllTypedDependencies(grammaticalStructures1);
        ArrayList<TypedDependency> typedDependencies2 = grammaticalStructureAllTypedDependencies(grammaticalStructures2);
        score = iterateTrees(this.treesF, this.trees1, score);
        score = typeDependenciesGrammaticalRelation(typedDependencies1, typedDependencies2, score, grammaticalStructures1, grammaticalStructures2,
                this.treesF, this.trees1);
        ArrayList<Integer> rnnCoreAnnotationsPredicted1 = sentimentRNNCoreAnnotations(this.sentencesSentimentF, sentimentAnnotatedTreeClass);
        ArrayList<Integer> rnnCoreAnnotationsPredicted2 = sentimentRNNCoreAnnotations(this.sentencesSentiment1, sentimentAnnotatedTreeClass);
        ArrayList<SimpleMatrix> simpleMatrices1 = sentimentRNNCorePredicted(this.sentencesSentimentF, sentimentAnnotatedTreeClass);
        ArrayList<SimpleMatrix> simpleMatrices2 = sentimentRNNCorePredicted(this.sentencesSentiment1, sentimentAnnotatedTreeClass);
        ArrayList<SimpleMatrix> simpleMatricesNodevectors1 = sentimentRNNCoreNodevectors(this.sentencesSentimentF, sentimentAnnotatedTreeClass);
        ArrayList<SimpleMatrix> simpleMatricesNodevectors2 = sentimentRNNCoreNodevectors(this.sentencesSentiment1, sentimentAnnotatedTreeClass);
        score = simpleRNNMatrixCalculations(score, simpleMatrices1, simpleMatrices2);
        score = simpleRNNMaxtrixVectors(score, simpleMatricesNodevectors1, simpleMatricesNodevectors2);
        Integer sentiment1 = rnnCoreAnnotationsPredicted1.size();
        Integer sentiment2 = rnnCoreAnnotationsPredicted2.size();
        score -= (sentiment1 > sentiment2 ? sentiment2 - sentiment1 : sentiment1 - sentiment2) * 500;
        score -= classifyRawEvaluation();

        int longest1 = setupMainLongest(this.sentencesSentimentF);
        int longest2 = setupMainLongest(this.sentencesSentiment1);
        int sentimentLongest1 = setupMainSentiment(this.sentencesSentimentF, sentimentAnnotatedTreeClass);
        int sentimentLongest2 = setupMainSentiment(this.sentencesSentiment1, sentimentAnnotatedTreeClass);
        score = sentimentMatrixVariances(score, longest1, longest2, sentimentLongest1, sentimentLongest2);

        int InflectedCounterNegative1 = 0;
        int InflectedCounterNegative2 = 0;
        int InflectedCounterPositive1 = 0;
        int InflectedCounterPositive2 = 0;

        ArrayList<List<CoreMap>> coreMapsList = new ArrayList<>();
        coreMapsList.add(this.coreMaps1);
        coreMapsList.add(this.coreMaps2);

        int MarkedContinuousCounter1 = 0;
        int MarkedContinuousCounter2 = 0;
        int UnmarkedPatternCounter1 = 0;
        int UnmarkedPatternCounter2 = 0;
        ArrayList<String> strTokensIpartForm1 = new ArrayList<>();
        ArrayList<String> strTokensIpartForm2 = new ArrayList<>();
        ArrayList<String> tokenEntry1 = new ArrayList<>();
        ArrayList<String> tokenEntry2 = new ArrayList<>();
        ArrayList<String> tokenForms1 = new ArrayList<>();
        ArrayList<String> tokenForms2 = new ArrayList<>();
        ArrayList<String> strTokenEntryGetPOS1 = new ArrayList<>();
        ArrayList<String> strTokenEntryGetPOS2 = new ArrayList<>();
        ArrayList<Integer> intTokenEntyCounts1 = new ArrayList();
        ArrayList<Integer> intTokenEntyCounts2 = new ArrayList();
        ArrayList<String> ITokenTags1 = new ArrayList<>();
        ArrayList<String> ITokenTags2 = new ArrayList<>();
        ArrayList<String> strTokenStems1 = new ArrayList<>();
        ArrayList<String> strTokenStems2 = new ArrayList<>();
        int Anotatorcounter1 = 0;
        int Anotatorcounter2 = 0;
        int TokensCounter1 = 0;
        int TokensCounter2 = 0;
        boolean firstAnnotation = true;

        for (List<CoreMap> coreMaps : coreMapsList) {
            int tokenadder = 0;
            Collection<IMWE<IToken>> tokeninflectionMap = new ArrayList();
            for (CoreMap sentence : coreMaps) {
                List<IMWE<IToken>> imwes = sentence.get(JMWEAnnotation.class);
                for (IMWE<IToken> token : imwes) {
                    Collection<IMWEDesc.IPart> values = token.getPartMap().values();
                    IMWEDesc entry = token.getEntry();
                    if (!token.isInflected() && !tokeninflectionMap.contains(token)) {
                        if (firstAnnotation) {
                            InflectedCounterNegative1++;
                        } else {
                            InflectedCounterNegative2++;
                        }
                        tokeninflectionMap.add(token);
                    } else if (token.isInflected()) {
                        if (firstAnnotation) {
                            InflectedCounterPositive1++;
                        } else {
                            InflectedCounterPositive2++;
                        }
                    }

                    String form = token.getForm();
                    final String substring = token.getEntry().toString().substring(token.getEntry().toString().length() - 1);
                    if (firstAnnotation) {
                        tokenEntry1.add(substring);
                        tokenForms1.add(form);
                    } else {
                        tokenEntry2.add(substring);
                        tokenForms2.add(form);
                    }
                    if (firstAnnotation) {
                        MarkedContinuousCounter1 += entry.getMarkedContinuous();
                    } else {
                        MarkedContinuousCounter2 += entry.getMarkedContinuous();
                    }
                    if (firstAnnotation) {
                        UnmarkedPatternCounter1 += entry.getUnmarkedPattern();
                    } else {
                        UnmarkedPatternCounter2 += entry.getUnmarkedPattern();
                    }
                    for (IMWEDesc.IPart iPart : values) {
                        String iPartForm = iPart.getForm();
                        if (firstAnnotation) {
                            strTokensIpartForm1.add(iPartForm);
                        } else {
                            strTokensIpartForm2.add(iPartForm);
                        }
                    }
                    for (String strPostPrefix : entry.getPOS().getPrefixes()) {
                        if (firstAnnotation) {
                            strTokenEntryGetPOS1.add(strPostPrefix);
                        } else {
                            strTokenEntryGetPOS2.add(strPostPrefix);
                        }
                    }
                    for (int counts : entry.getCounts()) {
                        if (firstAnnotation) {
                            intTokenEntyCounts1.add(counts);
                        } else {
                            intTokenEntyCounts2.add(counts);
                        }
                    }
                    for (IToken tokens : token.getTokens()) {
                        if (firstAnnotation) {
                            ITokenTags1.add(tokens.getTag());
                        } else {
                            ITokenTags2.add(tokens.getTag());
                        }
                        for (String strtoken : tokens.getStems()) {
                            if (firstAnnotation) {
                                strTokenStems1.add(strtoken);
                            } else {
                                strTokenStems2.add(strtoken);
                            }
                            if (firstAnnotation) {
                                MarkedContinuousCounter1++;
                            } else {
                                MarkedContinuousCounter2++;
                            }
                        }
                    }
                    tokenadder += 1;
                }
                if (firstAnnotation) {
                    Anotatorcounter1++;
                } else {
                    Anotatorcounter2++;
                }
            }
            firstAnnotation = false;
            if (firstAnnotation) {
                TokensCounter1 = tokenadder;
            } else {
                TokensCounter2 = tokenadder;
            }
        }

        score = entryCountsRelation(score, intTokenEntyCounts1, intTokenEntyCounts2);
        score = entryCountsScoring(score, intTokenEntyCounts1, intTokenEntyCounts2);
        score = tokenEntryPosScoring(score, strTokenEntryGetPOS1, strTokenEntryGetPOS2);
        score = unmarkedPatternCounterScoring(score, UnmarkedPatternCounter1, UnmarkedPatternCounter2);
        score = markedContiniousCounterScoring(score, MarkedContinuousCounter1, MarkedContinuousCounter2);
        score = strTokensMapScoring(score, strTokensIpartForm1, strTokensIpartForm2);
        score = strTokenEntryScoring(score, tokenEntry1, tokenEntry2);
        score = strTokenMapTagsScoring(score, ITokenTags1, ITokenTags2);
        score = tokenformSizeScoring(score, tokenForms1, tokenForms1);
        score = tokenStemmingMapScoring(score, strTokenStems1, strTokenStems2);

        score = inflectedCounterScoring(score, InflectedCounterPositive1, InflectedCounterPositive2,
                InflectedCounterNegative1, InflectedCounterNegative2);
        score = annotatorCountScoring(score, Anotatorcounter1, Anotatorcounter2);
        score = tokensCounterScoring(score, TokensCounter1, TokensCounter2);
        LevenshteinDistance leven = new LevenshteinDistance(str, str1);
        double SentenceScoreDiff = leven.computeLevenshteinDistance();
        SentenceScoreDiff *= 15;
        score -= SentenceScoreDiff;

        ArrayList<String> entityTokenTags1 = new ArrayList<>();
        ArrayList<String> entityTokenTags2 = new ArrayList<>();
        ArrayList<String> nerEntities1 = new ArrayList<>();
        ArrayList<String> nerEntities2 = new ArrayList<>();
        ArrayList<String> nerEntitiesType = new ArrayList<>();
        ArrayList<CoreDocument> pipelineCoreDocuments = new ArrayList<>();
        pipelineCoreDocuments.add(pipelineCoreDcoument1);
        pipelineCoreDocuments.add(pipelineCoreDcoument2);
        firstAnnotation = true;
        for (CoreDocument coreDocument : pipelineCoreDocuments) {
            for (CoreEntityMention em : coreDocument.entityMentions()) {
                Set<Map.Entry<String, Double>> entrySet = em.entityTypeConfidences().entrySet();
                String entityType = em.entityType();
                Double EntityConfidences = 0.0;
                for (Map.Entry<String, Double> entries : entrySet) {
                    EntityConfidences = entries.getValue();
                }
                List<CoreLabel> tokens = em.tokens();
                for (CoreLabel token : tokens) {
                    if (token != null) {
                        if (firstAnnotation) {
                            if (!entityTokenTags1.contains(token.tag())) {
                                if (entityType.equals("PERSON") && EntityConfidences > 0.80) {
                                    entityTokenTags1.add(token.tag());
                                }
                            }
                        } else {
                            if (!entityTokenTags2.contains(token.tag())) {
                                if (entityType.equals("PERSON") && EntityConfidences > 0.80) {
                                    entityTokenTags2.add(token.tag());
                                }
                            }
                        }
                    }
                }
                if (firstAnnotation) {
                    if (!nerEntities1.contains(em.text())) {
                        nerEntities1.add(em.text());
                        nerEntitiesType.add(em.entityType());
                    }
                } else {
                    if (!nerEntities2.contains(em.text())) {
                        nerEntities2.add(em.text());
                        nerEntitiesType.add(em.entityType());
                    }
                }
            }
            firstAnnotation = false;
        }
        score = nerEntitiesAndTokenScoring(score, entityTokenTags1, entityTokenTags2, nerEntities1, nerEntities2);
        ArrayList<Annotation> pipelineAnnotationSentiments = new ArrayList<>();
        ArrayList<String> stopWordToken1 = new ArrayList<>();
        ArrayList<String> stopWordToken2 = new ArrayList<>();
        ArrayList<String> stopWordLemma1 = new ArrayList<>();
        ArrayList<String> stopWordLemma2 = new ArrayList<>();
        int PairCounter1 = 0;
        int PairCounter2 = 0;
        pipelineAnnotationSentiments.add(pipelineAnnotation1Sentiment);
        pipelineAnnotationSentiments.add(pipelineAnnotation2Sentiment);

        firstAnnotation = true;
        for (Annotation pipelineAnnotationSentiment : pipelineAnnotationSentiments) {
            String customStopWordList = "start,starts,period,periods,a,an,and,are,as,at,be,but,by,for,if,in," +
                    "into,is,it,no,not,of,on,or,such,that,the,their,then,there,these,they,this,to,was,will,with";
            List<CoreLabel> tokensSentiment = pipelineAnnotationSentiment.get(CoreAnnotations.TokensAnnotation.class);
            Set<?> stopWords = StopAnalyzer.ENGLISH_STOP_WORDS_SET;
            Set<?> stopWordsCustom = StopwordAnnotator.getStopWordList(customStopWordList, true);
            for (CoreLabel token : tokensSentiment) {
                Pair<Boolean, Boolean> stopword = token.get(StopwordAnnotator.class);
                String word = token.word().toLowerCase();
                if (stopWords.contains(word) || stopWordsCustom.contains(word)) {
                    if (firstAnnotation) {
                        stopWordToken1.add(word);
                    } else {
                        stopWordToken2.add(word);
                    }
                }
                String lemma = token.lemma().toLowerCase();
                if (stopWords.contains(lemma) || stopWordsCustom.contains(lemma)) {
                    if (firstAnnotation) {
                        stopWordLemma1.add(lemma);
                    } else {
                        stopWordLemma2.add(lemma);
                    }
                }
                if (stopword.first() && stopword.second()) {
                    if (firstAnnotation) {
                        PairCounter1++;
                    } else {
                        PairCounter2++;
                    }
                }
            }
            firstAnnotation = false;
        }
        score = stopWordTokenLemmaScoring(score, stopWordToken1, stopWordToken2, stopWordLemma1, stopWordLemma2);
        score = stopwordTokenPairCounterScoring(score, stopWordToken1, stopWordToken2, PairCounter1, PairCounter2);
        smxParam.setDistance(score);
        return smxParam;
    }
}
